#include <iostream>
using namespace std;

class CPolygon {
protected:
    int area;
public:
    virtual int computeArea(void) = 0;
};

class CRectangle : virtual public CPolygon {
private:
    int width, height;
public:
    CRectangle(int w, int h) : width(w), height(h) {}
    int computeArea(void)    {
        area = width * height;
        return area;
    }
};

class CSquare : virtual public CPolygon {
private:
    int width;
public:
    CSquare(int w) : width(w) {}
    int computeArea(void)    {
        area = width * width;
        return area;
    }
};

int main() {
    CRectangle rect = CRectangle(3,4);
    CSquare square = CSquare(2);
    CPolygon * pPoly1 = &rect;
    CPolygon * pPoly2 = &square;
    cout << pPoly1->computeArea() << endl;
    cout << pPoly2->computeArea() << endl;
    return 0;
}
