#ifndef TESTCLASS_H
#define TESTCLASS_H

#include <iostream>

class TestClass
{
private:
    double value;
    int tmpValue;
public:
    // Constructors.
    TestClass();
    TestClass(const TestClass&);
    TestClass(const double&);

    // Destructor.
    ~TestClass();

    // Member functions (e.g. getters and setters).
    double getValue() const;
    void setValue(double);

    // Member operators (e.g. unary operator =).
    TestClass& operator=(const TestClass&);

    // Friend operators (e.g. binary operator).
    friend std::ostream& operator<<(std::ostream&, const TestClass&);

    // Friend functions
    friend TestClass compute(const TestClass&, const TestClass&);
};

#endif // TESTCLASS_H
